#include <iostream>
#include <gflags/gflags.h>
#include <glog/logging.h>
#include "dispatch/dispatch.h"
#include "serialize/blockserializer.h"

using namespace std;

DEFINE_string(pcd_dir, "", "pcd_dir");

void signaleHandle(const char* data, int size){
    string str = data;
    LOG(INFO) << "signaleHandle: " << str;
}

int main(int argc, char *argv[])
{
    gflags::ParseCommandLineFlags(&argc, &argv, true);
    google::InitGoogleLogging(argv[0]);
    google::InstallFailureSignalHandler();
    google::InstallFailureWriter(&signaleHandle);
    FLAGS_log_dir = "/home/juefx/log";
    FLAGS_alsologtostderr = true;
    FLAGS_colorlogtostderr = true;
    FLAGS_stderrthreshold = 0;
    FLAGS_logbufsecs = 0;

    Dispatch dispatch(FLAGS_pcd_dir);
    dispatch.dispatch();
    LOG(INFO) << "dispatch done";
    boost::shared_ptr<GridManager> blockManager =
            dispatch.getBlockManager();
    BlockSerializer blockSerializer(blockManager);
    blockSerializer.setOffset(dispatch.getOffset());
    blockSerializer.configSerialization();

    return 0;
}
