#ifndef DISPATCH_H
#define DISPATCH_H

#include "utils/basic_types.h"
#include "utils/basic_functions.h"
#include <boost/filesystem.hpp>
#include <pcl/io/pcd_io.h>
#include "utils/pcl_point_type.h"
#include "grid/gridmanager.h"

class Dispatch
{
public:
    Dispatch(const string &path);

    bool loadPCD(const string &path);

    boost::shared_ptr<GridManager> getBlockManager();

    void dispatch();

    Vector3f getOffset();
private:
    void dispatchPoint(const PointExport &point);

    void configBlockInfo(
            boost::shared_ptr<GridBase> blockGrid);
private:
    PointCloudExport::Ptr pointcloud_;

    boost::shared_ptr<GridManager> blockManager_;

    Vector3f offset_ = Vector3f::Zero();
};

#endif // DISPATCH_H
