#ifndef BLOCK_H
#define BLOCK_H

#include "gridbase.h"
#include "grid.h"
#include "gridmanager.h"
#include "proto_pb/block/block_info.pb.h"

class BlockGrid : public GridBase, public GridManager
{
public:
    BlockGrid(const Vector2i &index, float resolution);

    void configInfo();

    BlockInfo getBlockInfo();

    BlockDistribution_ getDistributions();
private:
    PointCloudExport::Ptr getBlockPointcloud();

    void reDispatch(PointCloudExport::Ptr pointcloud);
private:
    BlockInfo blockInfo_;

    BlockDistribution_ distribution_;

    bool hasGround_ = false;

};//end of class


#endif // BLOCK_H
