#include "grid.h"
#include "extractFunction.h"
#include "feature/featureExtraction.h"

Grid::Grid(const Vector2i &index, float resolution)
    :GridBase(index, resolution)
{
    pointcloud_.reset(new PointCloudExport);
}

void Grid::addPoint(const PointExport &point)
{
//    boost::unique_lock<boost::shared_mutex> lock(insertMtx_);
    pointcloud_->push_back(point);
}

PointCloudExport::Ptr Grid::getPointCloud()
{
    return pointcloud_;
}

void Grid::configInfo()
{
//    float zMax = numeric_limits<float>::lowest();
//    float zMin = numeric_limits<float>::max();
//    for(const auto &point : pointcloud_->points){
//        zMax = zMax > point.z ? zMax : point.z;
//        zMin = zMin < point.z ? zMin : point.z;
//    }
//    OneDistribution_ oneDistribution;
//    oneDistribution.floor = floor(zMin / ZResolution);
//    oneDistribution.z_delta_leval = (zMax - zMin) / ZResolution;
//    gridDtribution_.oneDistributions.push_back(oneDistribution);

//    vector<extrac> ret = extractFromBlock(pointcloud_);
//    for(const extrac& distribution : ret){
//        OneDistribution_ oneDistribution;
//        oneDistribution.floor = distribution.minz_devidedBy3;
//        oneDistribution.z_delta_level = distribution.deltaz_devidedBy3;
//        oneDistribution.intensity = distribution.intensity / 8;
//        gridDtribution_.oneDistributions.push_back(oneDistribution);
//    }

    vector<gridFeature> result;
    //构建特征提取类
    featureExtraction fe;
    //使用点云初始化
    fe.initializeGridFeature(pointcloud_);
    //获取结果
    fe.getFeature(result);

    for(const gridFeature& distribution : result){
        OneDistribution_ oneDistribution;
        oneDistribution.floor = distribution.minz_devidedByResolution;
        oneDistribution.z_delta_level = distribution.deltaz_devidedByResolution;
        oneDistribution.intensity = distribution.intensity / 8;
        gridDtribution_.oneDistributions.push_back(oneDistribution);
        hasGround_ = hasGround_ || distribution.labeled;
    }
}

GridDistribution_ Grid::getGridDistribution()
{
    return gridDtribution_;
}

bool Grid::getHasGround()
{
    return hasGround_;
}
