#ifndef GRID_H
#define GRID_H

#include "gridbase.h"
#include "utils/pcl_point_type.h"
#include "proto_pb/distribution/distribution.pb.h"

class Grid : public GridBase
{
public:
    Grid(const Vector2i &index, float resolution);

    void addPoint(const PointExport &point);

    PointCloudExport::Ptr getPointCloud();

    void configInfo();

    GridDistribution_ getGridDistribution();

     bool getHasGround();
private:
    PointCloudExport::Ptr pointcloud_;

    boost::shared_mutex insertMtx_;

    GridDistribution_ gridDtribution_;

    bool hasGround_ = false;

};

#endif // GRID_H
