#ifndef BLOCKSERIALIZER_H
#define BLOCKSERIALIZER_H

#include "grid/gridmanager.h"
#include "grid/block.h"

class BlockSerializer
{
public:
    BlockSerializer(boost::shared_ptr<GridManager> blockManager);

    void configSerialization();

    void setOffset(const Vector3f &offset);
private:

private:
    boost::shared_ptr<GridManager> blockManager_;

    vector<IndexDistribution> indexDistributionVec_;

    boost::shared_mutex mtx_;

    Vector3f offset_ = Vector3f::Zero();

};

#endif // BLOCKSERIALIZER_H
