#ifndef SYS_UTILS_H
#define SYS_UTILS_H

#include <sys/resource.h>

const char data_mem[] = "VmRSS:";

void print_mem(int pid)
{
    FILE *stream;
    char cache[256];
    char mem_info[64];

    sprintf(mem_info, "/proc/%d/status", pid);
    stream = fopen(mem_info, "r");
    if (stream == NULL) {
        return;
    }

    while(fscanf(stream, "%s", cache) != EOF) {
        if (strncmp(cache, data_mem, sizeof(data_mem)) == 0) {
            if (fscanf(stream, "%s", cache) != EOF) {
                LOG(INFO) << "current memory: " << string(cache);
                break;
            }
        }
    }
}

int SysMem()
{
    const int MAX_LEN=1024;
    char sInfo[MAX_LEN];
    char strInfo[1024];

    //
    long mem_used = -1;
    long mem_free = -1;
    long mem_total = -1;
    char name[20];
           float fMemRate;

    FILE *fp;
    char buf1[128];
    char buf2[128];
    int i = 0;

    memset(sInfo, 0x00, sizeof(sInfo));
    memset(strInfo, 0x00, sizeof(strInfo));

    //读取文件中mem信息
    fp = fopen("/proc/meminfo","r");
    if(fp == NULL)
    {
     perror("fopen:");
     return -1;
    }
    fgets(buf1,sizeof(buf1),fp);
    fgets(buf2,sizeof(buf2),fp);
    fclose(fp);

    //计算
    strcpy(strInfo," RTOL(kb)      FREE(kb)        RINUSE(kb)       RATE%%\n\n");
    sscanf(buf1,"%s%ld",name,&mem_total);
    sscanf(buf2,"%s%ld",name,&mem_free);
    mem_used = mem_total - mem_free;
    fMemRate = 1.0 * mem_used / mem_total;
    sprintf(sInfo,"% 6ld     %6ld         %6ld      %6.1f\n",mem_total,mem_free,mem_used,fMemRate);
    strcat(strInfo,sInfo);
//    printf("%s\n",strInfo);
    return mem_total;
}

#endif // SYS_UTILS_H
